import { useState, useEffect } from 'react';

var useTypingEffect = function (strings, _a) {
    if (strings === void 0) { strings = ['']; }
    var _b = _a === void 0 ? {
        loop: false,
        playbackRate: 1
    } : _a, _c = _b.loop, loop = _c === void 0 ? false : _c, _d = _b.playbackRate, playbackRate = _d === void 0 ? 1 : _d;
    var _e = useState({
        stringIndex: 0,
        characterIndex: 0
    }), _f = _e[0], stringIndex = _f.stringIndex, characterIndex = _f.characterIndex, setState = _e[1];
    var timeoutId;
    var emulateKeyStroke = function () {
        characterIndex++;
        if (characterIndex === strings[stringIndex].length) {
            characterIndex = 0;
            stringIndex++;
            if (stringIndex === strings.length) {
                if (!loop) {
                    return;
                }
                stringIndex = 0;
            }
            timeoutId = window.setTimeout(emulateKeyStroke, 100 * playbackRate);
        }
        else if (characterIndex === strings[stringIndex].length - 1) {
            timeoutId = window.setTimeout(emulateKeyStroke, 2000 * playbackRate);
        }
        else {
            timeoutId = window.setTimeout(emulateKeyStroke, 100 * playbackRate);
        }
        setState({
            characterIndex: characterIndex,
            stringIndex: stringIndex
        });
    };
    useEffect(function () {
        emulateKeyStroke();
        return function () {
            window.clearTimeout(timeoutId);
        };
    }, []);
    var nonBreakingSpace = '\u00A0';
    return strings[stringIndex].slice(0, characterIndex + 1) || nonBreakingSpace;
};

export default useTypingEffect;
export { useTypingEffect };
//# sourceMappingURL=index.es.js.map
